// LoraBBS Version 2.41 Free Edition
// Copyright (C) 1987-98 Marco Maccaferri
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
// History:
// 19.03.1999 MOD006: CONFIG_VERSION set to '6'. (bt)
// 26.12.2001 MOD047: A new datafield added to _nodeinfo. (bt)

#include "defines.h"
#include "lora.h"

#define CONFIG_VERSION  6

#define MAXNL 20
#define MAXPACKER 10

/*
typedef unsigned int   bit;            //2 Byte
typedef unsigned short word;           //2 Byte
typedef unsigned char  byte;           //1 Byte
typedef long           dword;          //4 Byte
*/

struct _configuration {
	short version;                       // 2

	char  sys_path[40];                  // 40

	char  log_name[40];                  // 40
	char  log_style;                     // 1

	char  sched_name[40];                // 40
	char  user_file[40];                 // 40

	char  norm_filepath[40];             // 40
	char  know_filepath[40];             // 40
	char  prot_filepath[40];             // 40
	char  outbound[40];                  // 40
	char  netmail_dir[40];               // 40
	char  bad_msgs[40];                  // 40
	char  dupes[40];                     // 40
	char  quick_msgpath[40];             // 40
	char  pip_msgpath[40];               // 40
	char  ipc_path[40];                  // 40
	char  net_info[40];                  // 40
	char  glob_text_path[40];            // 40
	char  menu_path[40];                 // 40
	char  flag_dir[40];                  // 40

	long  keycode;                       // 4

	char  about[40];                     // 40
	char  files[40];                     // 40
	short norm_max_kbytes;               // 2
	short prot_max_kbytes;               // 2
	short know_max_kbytes;               // 2
	short norm_max_requests;             // 2
	short prot_max_requests;             // 2
	short know_max_requests;             // 2
	char  def_pack;                      // 1

	char  enterbbs[70];                  // 70
	char  banner[70];                    // 70
	char  mail_only[70];                 // 70

	short com_port;                      // 2
	short old_speed;                     // 2
	char  modem_busy[20];                // 20
	char  dial[20];                      // 20
	char  init[40];                      // 40
	char  term_init[40];                 // 40

	byte  mustbezero;                    // 1

	byte  echomail_exit;                 // 1
	byte  netmail_exit;                  // 1
	byte  both_exit;                     // 1

	long  speed;                         // 4
	short modem_OK_errorlevel;           // 2

	byte  filler[10];                    // 10

	struct _altern_dial {
		char prefix[20];
		char suffix[20];
	} altdial[10];                       // 400

	bit   lock_baud   :1;
	bit   ansilogon   :2;
	bit   birthdate   :1;
	bit   voicephone  :1;
	bit   dataphone   :1;
	bit   emsi        :1;
	bit   ibmset      :1;                // 1

	bit   wazoo       :1;
	bit   msgtrack    :1;
	bit   keeptransit :1;
	bit   hslink      :1;
	bit   puma        :1;
	bit   secure      :1;
	bit   janus       :1;
	bit   terminal    :1;                // 1

	bit   fillerbug   :1;
	bit   no_direct   :1;
	bit   snooping    :1;
	bit   snow_check  :1;
	bit   unpack_norm :1;
	bit   unpack_know :1;
	bit   unpack_prot :1;                // 1

	short blank_timer;                   // 2

//#define MAX_LANG 20

	struct _language {
		char txt_path[30];
		char descr[24];
		char basename[10];
	} language[MAX_LANG];                // 1280

	char  sysop[36];                     // 36
	char  system_name[50];               // 50
	char  location[50];                  // 50
	char  phone[32];                     // 32
	char  flags[50];                     // 50

/*	struct _alias
	{
	 short zone;
	 short net;
	 short node;
	 short point;
	 word  fakenet;
	 char  *domain;
	}; */ //14 Byte

	struct _alias old_alias[20];         // 280

	char  newareas_create[50];           // 50
	char  newareas_link[50];             // 50

	short line_offset;                   // 2
	short min_calls;                     // 2
	short vote_limit;                    // 2
	short target_up;                     // 2
	short target_down;                   // 2
	byte  vote_priv;                     // 1
	byte  max_readpriv;                  // 1

	word  speed_graphics;                // 2

	byte  aftercaller_exit;              // 1
	byte  aftermail_exit;                // 1
	short max_connects;                  // 2
	short max_noconnects;                // 2

	byte  logon_level;                   // 1
	long  logon_flags;                   // 4

	char  areachange_key[4];             // 4
	char  dateformat[20];                // 20
	char  timeformat[20];                // 20
	char  external_editor[50];           // 50

/*	struct class_rec
	{
	 short priv;
	 short max_time;
	 short max_call;
	 short max_dl;
	 short dl_300;
	 short dl_1200;
	 short dl_2400;
	 short dl_9600;
	 word  ratio;
	 word  min_baud;
	 word  min_file_baud;
	 word  start_ratio;
	}; */ //24 Byte

	struct class_rec class[12];          // 288

	char  local_editor[50];              // 50

	char  QWKDir[40];                    // 40
	char  BBSid[10];                     // 10
	word  qwk_maxmsgs;                   // 2

	char  galileo[30];                   // 30

	char  norm_okfile[40];               // 40
	char  know_okfile[40];               // 40
	char  prot_okfile[40];               // 40

	char  reg_name[36];                  // 36
	long  betakey;                       // 4

	struct _packers {
		char id[10];
		char packcmd[30];
		char unpackcmd[30];
	} packers[10];                       // 700

	struct _nl {
		char list_name[14];
		char diff_name[14];
		char arc_name[14];
	} old_nl[10];                        // 420

	bit   ansigraphics   :2;
	bit   avatargraphics :2;
	bit   hotkeys        :2;
	bit   screenclears   :2;             // 1

	bit   autozmodem     :1;
	bit   avatar         :1;
	bit   moreprompt     :2;
	bit   mailcheck      :2;
	bit   fullscrnedit   :2;             // 1

	bit   fillerbits     :2;
	bit   ask_protocol   :1;
	bit   ask_packer     :1;
	bit   put_uploader   :1;
	bit   keep_dl_count  :1;
	bit   use_areasbbs   :1;
	bit   write_areasbbs :1;             // 1

	short rookie_calls;                  // 2

	char  pre_import[40];                // 40
	char  after_import[40];              // 40
	char  pre_export[40];                // 40
	char  after_export[40];              // 40

	byte  emulation;                     // 1
	char  dl_path[40];                   // 40
	char  ul_path[40];                   // 40

	bit   manual_answer  :1;
	bit   limited_hours  :1;
	bit   solar          :1;
	bit   areafix        :1;
	bit   doflagfile     :1;
	bit   multitask      :1;
	bit   ask_alias      :1;
	bit   random_birth   :1;             // 1

	short start_time;                    // 2
	short end_time;                      // 2

	char  boxpath[40];                   // 40
	char  dial_suffix[20];               // 20

	char  galileo_dial[40];              // 40
	char  galileo_suffix[40];            // 40
	char  galileo_init[40];              // 40

	char  areafix_help[40];              // 40
	char  alert_nodes[50];               // 50

	char  automaint[40];                 // 40

	byte  min_login_level;               // 1
	long  min_login_flags;               // 4
	byte  min_login_age;                 // 1

	char  resync_nodes[50];              // 50
	char  bbs_batch[40];                 // 40
	byte  altx_errorlevel;               // 1

	char  fax_response[20];              // 20
	byte  fax_errorlevel;                // 1

	char  dl_counter_limits[4];          // 4

	char  areas_bbs[40];                 // 40
	byte  afx_remote_maint;              // 1
	byte  afx_change_tag;                // 1

	bit   allow_rescan    :1;
	bit   check_city      :1;
	bit   check_echo_zone :1;
	bit   save_my_mail    :1;
	bit   mail_method     :2;
	bit   replace_tear    :2;            // 1

	char  my_mail[40];                   // 40

	bit   stripdash       :1;
	bit   use_iemsi       :1;
	bit   newmail_flash   :1;
	bit   mymail_flash    :1;
	bit   keep_empty      :1;
	bit   show_missing    :1;
	bit   random_redial   :1;            // 1

	char  override_pwd[20];              // 20
	char  pre_pack[40];                  // 40
	char  after_pack[40];                // 40

	byte  modem_timeout;                 // 1
	byte  login_timeout;                 // 1
	byte  inactivity_timeout;            // 1

	struct _altern_prefix {
		char flag[6];
		char prefix[20];
	} prefixdial[10];                    // 260

	char  iemsi_handle[36];              // 36
	char  iemsi_pwd[20];                 // 20
	short iemsi_infotime;                // 2

	bit   iemsi_on        :1;
	bit   iemsi_hotkeys   :1;
	bit   iemsi_quiet     :1;
	bit   iemsi_pausing   :1;
	bit   iemsi_editor    :1;
	bit   iemsi_news      :1;
	bit   iemsi_newmail   :1;
	bit   iemsi_newfiles  :1;            // 1

	bit   iemsi_screenclr :1;
	bit   prot_xmodem     :1;
	bit   prot_1kxmodem   :1;
	bit   prot_zmodem     :1;
	bit   prot_sealink    :1;
	bit   tic_active      :1;
	bit   tic_check_zone  :1;
	bit   filebox         :1;            // 1

	char  newkey_code[30];               // 30
	char  tearline[36];                  // 36

	char  uucp_gatename[20];             // 20
	short uucp_zone;                     // 2
	short uucp_net;                      // 2
	short uucp_node;                     // 2

	byte  carrier_mask;                  // 1
	byte  dcd_timeout;                   // 1

	struct _packid{
		char  display[20];
		short offset;
		char  ident[20];
	} packid[10];                        // 420

	char  quote_string[5];               // 5
	char  quote_header[50];              // 50

	char  tic_help[40];                  // 40
	char  tic_alert_nodes[50];           // 50
	char  tic_newareas_create[50];       // 50
	char  tic_newareas_link[50];         // 50
	byte  tic_remote_maint;              // 1
	byte  tic_change_tag;                // 1

	short uucp_point;                    // 2

	byte  dial_timeout;                  // 1
	byte  dial_pause;                    // 1

	bit   newfilescheck  :2;
	bit   mono_attr      :1;
	bit   force_intl     :1;
	bit   inp_dateformat :2;
	bit   single_pass    :1;
	bit   cdrom_swap     :1;             // 1

	short ul_free_space;                 // 2
	char  hangup_string[40];             // 40
	char  init2[40];                     // 40
	char  init3[40];                     // 40

	short page_start[7];                 // 14
	short page_end[7];                   // 14

	char  logbuffer;                     // 1

	char  newareas_path[40];             // 40
	char  newareas_base;                 // 1

	char  answer[40];                    // 40

	bit   blanker_type   :3;
	bit   tcpip          :2;
	bit   export_internet:1;             // 1

	char  internet_gate;                 // 1

	char  areafix_watch[50];             // 50
	char  tic_watch[50];                 // 50

	byte  netmail;                       // 1
	byte  echomail;                      // 1
	byte  internet;                      // 1
	byte  net_echo;                      // 1
	byte  echo_internet;                 // 1
	byte  net_internet;                  // 1
	byte  echo_net_internet;             // 1

	char  upload_check[50];              // 50
	unsigned long setup_pwd;             // 4

//#define MAX_ALIAS 40

	struct _alias alias[MAX_ALIAS];      // 560

/*   struct old_nl {
		char list_name[14];
		char diff_name[14];
		char arc_name[14];
	} nl[MAXNL];
*/

	struct _nl nl[MAXNL];                // 840
	char  filler_2 [565];                // 565
}; //9592 Byte

typedef struct _nodeinfo {
	short zone;                          // 2
	short net;                           // 2
	short node;                          // 2
	short point;                         // 2
	short afx_level;                     // 2
	char  pw_session[20];                // 20
	char  pw_areafix[20];                // 20
	char  pw_tic[20];                    // 20
	char  pw_packet[9];                  // 9
	short modem_type;                    // 2
	char  phone[30];                     // 30
	short packer;                        // 2
	char  sysop_name[36];                // 36
	char  system[36];                    // 36
//Up to 8 'bit' are only using one single Byte of memory!!
//These 7 'bit' are only using 1 Byte of memory.
	bit   remap4d      :1;
	bit   can_do_22pkt :1;
	bit   wazoo        :1;
	bit   emsi         :1;
	bit   janus        :1;
	bit   pkt_create   :2;
//MOD047: A new datafield added. (bt)
	bit   pr_emsi      :1;               // 1

	char  aka;                           // 1
	short tic_level;                     // 2
	long  afx_flags;                     // 4
	long  tic_flags;                     // 4
	char  tic_aka;                       // 1
	long  baudrate;                      // 4
	char  pw_inbound_packet[9];          // 9
	char  mailer_aka;                    // 1
	long  min_baud_rate;                 // 4
	char  filler[40];                    // 40
} NODEINFO; //256 Byte

typedef struct _node2name {
	char  name[36];                      // 36
	short zone;                          // 2
	short net;                           // 2
	short node;                          // 2
	short point;                         // 2
} NODE2NAME; //44 Byte

#define MAXCOST 20

typedef struct _translation {
	char  location[30];                  // 30
	char  search[20];                    // 20
	char  traslate[60];                  // 60
	struct _cost {
		short days;
		short start;
		short stop;
		short cost_first;
		short time_first;
		short cost;
		short time;
		bit   crash    :1;
		bit   direct   :1;
		bit   normal   :1;
	} cost[MAXCOST];                     // 300
} ACCOUNT;  //410 Byte

typedef struct _protocol{
	char  name[30];                      // 30
	char  hotkey;                        // 1

	bit   active          :1;
	bit   batch           :1;
	bit   disable_fossil  :1;
	bit   change_to_dl    :1;            // 1

	char  dl_command[80];                // 80
	char  ul_command[80];                // 80
	char  log_name[40];                  // 40
	char  ctl_name[40];                  // 40
	char  dl_ctl_string[40];             // 40
	char  ul_ctl_string[40];             // 40
	char  dl_keyword[20];                // 20
	char  ul_keyword[20];                // 20
	short filename;                      // 2
	short size;                          // 2
	short cps;                           // 2
} PROTOCOL; //398 Byte
